Include "HJConst.jsh"
Include "common.jsm"
Include "SelBlock.jsh"
Include "SelBlock.jsm"

Script SelectBlock (int Sel)
Var
string sFunc

If UserBufferIsActive () Then
	let sFunc = "SimpleMark"
ElIf IsVirtualPCCursor () Then
	let sFunc = "SimpleMark"
ElIf IsEdit () Then
	let sFunc = stringStripAllBlanks (GetWindowClass (GetFocus ()))
EndIf
If Sel Then
let gSB_SelMode = True
	let sFunc = "_" + sFunc
Else
let gSB_SelMode = False
	ScheduleFunction ("SaveStart", 0)
EndIf
ScheduleFunction ("PostFunc", 0)
ScheduleFunction (sFunc, 0)
ScheduleFunction ("PreFunc", 0)
EndScript

Function PreFunc ()
let gSB_NoFunc = True
SpeechOff ()
EndFunction

Function PostFunc ()
Pause ()
SpeechOn ()
If gSB_NoFunc Then
	SayCurrentScriptKeyLabel ()
	TypeCurrentScriptKey()
	Return
EndIf
If !gSB_SelMode Then
	SayMessage (	OT_NO_DISABLE , msgMarked)
	Return
EndIf
If gSB_Size Then
	SayMessage (OT_NO_DISABLE , FormatString (msgSelected, IntToString (gSB_Size)))
EndIf
EndFunction

Function Edit ()
Var
handle hWnd,
int i, int i1, int i11

let gSB_NoFunc = False
let hWnd = GetFocus ()
UnSelect (hWnd)
let i1 = SendMessage (hWnd, EM_LINEINDEX, -1)
let i11 = i1 % MaxInt
let i = HighWord (SendMessage (hWnd, EM_GETSEL))
If i < i11 Then
	let gSB_RetVal = i1 + (MaxInt -i11) + i
	Return 
EndIf
let gSB_RetVal = i1 + i - i11
EndFunction

Function _Edit ()
Edit ()
SendMessage (GetFocus (), EM_SETSEL, gSB_Start, gSB_RetVal)
let gSB_Size = GetSize (gSB_Start, gSB_RetVal)
EndFunction

Function RichEdit20w ()
let gSB_NoFunc = False
TOM_GetSelection (GetRichEditDocument().Selection)
EndFunction

Function _RichEdit20w ()
RichEdit20W ()
TOM_Select (GetRichEditDocument().Selection)
EndFunction

Function RichEdit50w ()
Edit()
EndFunction

Function _RichEdit50w ()
_Edit()
EndFunction

Function _WwG ()
let gSB_NoFunc = False
TOM_GetSelection (GetNativeOMFromMSAA ().Selection)
EndFunction

Function __WwG ()
_WwG ()
TOM_Select (GetNativeOMFromMSAA ().Selection)
EndFunction

Function SimpleMark ()
let gSB_NoFunc = False
Let gSB_Row= GetCursorRow()
Let gSB_Col= GetCursorCol()
EndFunction

Function _SimpleMark ()
SimpleMark()
GoToPosition(gSB_StartRow, gSB_StartCol)
If (gSB_StartRow> gSB_Row) || ((gSB_StartRow== gSB_Row) && (gSB_StartCol> gSB_Col)) Then
	BackwardSelection ()
Else
	ForwardSelection ()
EndIf
let gSB_Size = StringLength (GetSelectedText ())
EndFunction

Function SaveStart ()
let gSB_Start = gSB_RetVal
let gSB_StartCol = gSB_Col
let gSB_StartRow = gSB_Row
EndFunction

Int Function IsEdit ()
Return !MenusActive () && !DialogActive () && IsPCCursor () 
EndFunction

Int Function GoToPosition(Int iRow, Int iCol)
GoToLineNumber(iRow)
While (iRow ==GetCursorRow()) && (iCol != GetCursorCol())
 NextCharacter()
EndWhile
Return (iRow ==GetCursorRow()) && (iCol == GetCursorCol())
EndFunction

Function TOM_Select (object oSel)
let oSel.Start = Min (gSB_Start, gSB_RetVal)
let oSel.End = Max (gSB_Start, gSB_RetVal)
let gSB_Size = GetSize (gSB_Start, gSB_RetVal)
EndFunction

Function TOM_GetSelection (object oSel)
If oSel.Flags & 1 Then
	let gSB_RetVal = oSel.Start
Else
let gSB_RetVal = oSel.End
EndIf
EndFunction

Function ForwardSelection ()
let gSB_Time = SysGetTime ("ss")
While (gSB_Row > gSB_StartRow) && (gSB_StartRow== GetCursorRow())
	SelectNextCharacter()
	SndProcess ()
EndWhile
While gSB_Row> GetCursorRow() + 1
	SelectNextLine()
	SndProcess ()
EndWhile
While (gSB_Row> GetCursorRow()) || ((gSB_Row== GetCursorRow()) && (gSB_Col> GetCursorCol()))
	SelectNextCharacter()
	SndProcess ()
EndWhile
EndFunction

Function BackwardSelection ()
let gSB_Time = SysGetTime ("ss")
While (gSB_Row < gSB_StartRow) && (gSB_Row== GetCursorRow())
	SelectPriorCharacter ()
	SndProcess ()
EndWhile
While gSB_Row< GetCursorRow()
	SelectPriorLine ()
	SndProcess ()
EndWhile
While (gSB_Row< GetCursorRow()) || ((gSB_Row== GetCursorRow()) && (gSB_Col< GetCursorCol()))
	SelectPriorCharacter ()
	SndProcess ()
EndWhile
EndFunction

int Function GetSize (int a, int b)
If a > b Then
	Return a - b
EndIf
Return b - a
EndFunction

Function SndProcess ()
Var
string sTime
let sTime = SysGetTime ("ss") 
If gSB_Time != sTime Then
	PlaySound (GetSharedSettingsDirectory ()+"\\SOUNDS\\Click3.wav")
	let gSB_Time = sTime
EndIf
EndFunction

Function UnSelect (handle hWnd)
SendMessage (hWnd, EM_SETSEL, -1, -1)
EndFunction
